commit 654555804ad0faec6ae5017d0b3da64e2a5d002d
Merge: 786fe33650a d71d742d09d
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu Aug 29 10:06:20 2024 +0530

    Merge pull request #5388 from VarunNagaraju/PS-9352
    
    PS-9352 Avoid out of bounds access due to ulong bitmask

commit 51fa3a62d02245e105f0c3e3f3f18df9ebe0c2f5
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Wed Oct 30 13:38:23 2024 +0530

    PS-9434 mysqldump blindly trusting SHOW CREATE TABLE leads to arbitrary code execution.
    
    https://perconadev.atlassian.net/browse/PS-9434
    
    WL#16482 mysql/mysql-server@2cc37b271ef
    
    Introduced a --[skip-]system-command command line/config file option
    for the mysql binary.
    Type: boolean
    Default: ON, can be turned off with --skip-system-command
    
    When --skip-system-command is specified and a system command or the
    abbreviated \! is specified, an error will be printed and the command
    won't be executed.
    
    Test case added.
    
    Change-Id: I46e8f3cc8e8a6aa37f8374c04a87177604cd124e

diff --git a/client/mysql.cc b/client/mysql.cc
index 22a2756a236..a2904580424 100644
--- a/client/mysql.cc
+++ b/client/mysql.cc
@@ -1,5 +1,5 @@
 /*
-   Copyright (c) 2000, 2023, Oracle and/or its affiliates.
+   Copyright (c) 2000, 2024, Oracle and/or its affiliates.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2.0,
@@ -372,7 +372,7 @@ static COMMANDS commands[] = {
     "Execute an SQL script file. Takes a file name as an argument."},
   { "status", 's', com_status, 0, "Get status information from the server."},
 #ifdef USE_POPEN
-  { "system", '!', com_shell,  1, "Execute a system shell command."},
+  { "system", '!', com_shell,  1, "Execute a system shell command, if enabled."},
 #endif
   { "tee",    'T', com_tee,    1, 
     "Set outfile [to_outfile]. Append everything into given outfile." },
@@ -1635,6 +1635,10 @@ unsigned short get_terminal_width()
   return 80;
 }
 
+#ifdef USE_POPEN
+static bool opt_system_command = true;
+#endif
+
 static struct my_option my_long_options[] =
 {
   {"help", '?', "Display this help and exit.", 0, 0, 0, GET_NO_ARG, NO_ARG, 0,
@@ -1893,6 +1897,12 @@ static struct my_option my_long_options[] =
    "test purpose, so it is just built when DEBUG is on.",
    &opt_build_completion_hash, &opt_build_completion_hash, 0, GET_BOOL,
    NO_ARG, 0, 0, 0, 0, 0, 0},
+#endif
+#ifdef USE_POPEN
+  {"system-command", 0,
+   "Enable (by default) or disable the system mysql command.",
+   &opt_system_command, &opt_system_command, 0, GET_BOOL, NO_ARG,
+   1, 0, 0, 0, 0, 0},
 #endif
   { 0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
 };
@@ -4583,6 +4593,14 @@ com_shell(String *buffer MY_ATTRIBUTE((unused)),
     put_info("Usage: \\! shell-command", INFO_ERROR);
     return -1;
   }
+
+  if (!opt_system_command) {
+    return put_info(
+        "'system' command received, but the --system-command option is off. "
+        "Skipping.",
+        INFO_ERROR);
+  }
+
   /*
     The output of the shell command does not
     get directed to the pager or the outfile
diff --git a/mysql-test/r/mysql.result b/mysql-test/r/mysql.result
index 3fd20d2c813..73b87630652 100644
--- a/mysql-test/r/mysql.result
+++ b/mysql-test/r/mysql.result
@@ -537,5 +537,13 @@ mysql: [Warning] Using a password on the command line interface can be insecure.
 user()
 bug21464621@localhost
 DROP USER bug21464621;
+#
+# Bug # 36377685: mysqldump blindly trusting SHOW CREATE TABLE leads to
+#   arbitrary code execution.
+#
+# Test "system": Must return an error
+ERROR at line 1: 'system' command received, but the --system-command option is off. Skipping.
+# Test "!": Must return an error
+ERROR at line 1: 'system' command received, but the --system-command option is off. Skipping.
 
 End of tests
diff --git a/mysql-test/t/mysql.test b/mysql-test/t/mysql.test
index 1c1bcdba12e..6866eefda04 100644
--- a/mysql-test/t/mysql.test
+++ b/mysql-test/t/mysql.test
@@ -662,5 +662,18 @@ CREATE USER bug21464621 IDENTIFIED BY 'password' PASSWORD EXPIRE;
 #cleanup
 DROP USER bug21464621;
 
+
+--echo #
+--echo # Bug # 36377685: mysqldump blindly trusting SHOW CREATE TABLE leads to
+--echo #   arbitrary code execution.
+--echo #
+--echo # Test "system": Must return an error
+--error 1
+--exec $MYSQL test --skip-system-command -e "system ls;" 2>&1
+
+--echo # Test "!": Must return an error
+--error 1
+--exec $MYSQL test --skip-system-command -e "\\! ls" 2>&1
+
 --echo
 --echo End of tests

